unit utlBase;

interface

function postdec(var i:integer):integer;
function predec(var i:integer):integer;
function postinc(var i:integer):integer;
function preinc(var i:integer):integer;

function min(x,y:variant):variant;
function max(x,y:variant):variant;

function cond(condition:boolean; iftrue,iffalse:variant):variant;
function caseof(x:variant;ins,outs:array of variant;default:variant):variant;
procedure debugstop; // To hang your breakpoint on. Won't be optimized away.

implementation

function postdec(var i:integer):integer;
begin
  result:=i;
  dec(i);
end;

function predec(var i:integer):integer;
begin
  dec(i);
  result:=i;
end;

function postinc(var i:integer):integer;
begin
  result:=i;
  inc(i);
end;

function preinc(var i:integer):integer;
begin
  inc(i);
  result:=i;
end;

function min(x,y:variant):variant;
begin
  if x<y then
    result:=x
  else
    result:=y;
end;

function max(x,y:variant):variant;
begin
  if x>y then
    result:=x
  else
    result:=y;
end;

function cond(condition:boolean; iftrue,iffalse:variant):variant;
begin
  if condition then result:=iftrue else result:=iffalse;
end;

function caseof(x:variant;ins,outs:array of variant;default:variant):variant;
var i:integer;
begin
  result:=default;
  for i:=low(ins) to high(ins) do
    if x=ins[i] then
    begin
      result:=outs[i];
      exit;
    end;
end;

{
Use debugstop to hang your breakpoint on so it won't
be optimized away. E.g:

  if condition then
    debugstop               // set you breakpoint on this line

}
var dummy:integer;
procedure debugstop;
begin
  inc(dummy);
end;






end.
